# -------[ Wall Climbing ]------- #

#Add the wallclimb tag to the player when they are looking at stone, and remove it when they are not. The commands have been anchored at their feet to make sure that they cannot wall climb on 1 block tall walls at eye level.

execute at @s anchored feet if block ^ ^ ^1 stone run tag @s add wallclimb
execute at @a anchored feet unless block ^ ^-0.1 ^1 stone run tag @s remove wallclimb

#Summon a shulker underneath the player with the wallclimb tag as long as there is not another shulker within 3 blocks of the players feet. This allows the player to jump and then have a shulker summon directly under their feet, but prevents entity spamming and lag. The shulkers have been given the invsibility effect even though this is rendered obsolete by the fact that their texture has been removed.

execute as @a[tag=wallclimb] at @s anchored eyes if block ^ ^ ^1 stone anchored feet unless entity @e[tag=wall,distance=..3] run summon armor_stand ~ ~-2.5 ~ {NoGravity:1b,Passengers:[{id:"minecraft:shulker",Silent:1b,Invulnerable:1b,NoAI:1b,CanPickUpLoot:0b,Health:1f,AttachFace:0b,Tags:["wallclimb"],ActiveEffects:[{Id:14b,Amplifier:20b,Duration:99999,ShowParticles:0b}]}],Tags:["wall"],Invisible:1}

execute as @e[tag=wall] at @s run tp @s ~ ~-0.07 ~
execute as @e[tag=wall] at @s unless entity @a[distance=..3.5] run tp @s 0.66 4.00 0.20
execute as @e[tag=wallclimb] at @s unless entity @a[distance=..2.5] run tp @s 0.66 4.00 0.20

#Once the shulker is 3.5 blocks away from the players feet, it is teleport it to 0.66 4 0.2 where it will be killed. This prevents extra entities from existing in the world and also prevents death particles from appearing when the player jumps or moves on the wall.
