# -------[ Wall Running ]------- #

#Summon a shulker underneath the player with the wallclimb tag as long as there is not another shulker within 3 blocks of the players feet. This allows the player to jump and then have a shulker summon directly under their feet, but prevents entity spamming and lag. The shulkers have been given the invsibility effect even though this is rendered obsolete by the fact that their texture has been removed.

execute as @a[scores={walk=..0}] run scoreboard players add @s paused 1
execute as @a[scores={walk=1..}] run scoreboard players set @s paused 0
execute as @a[scores={sprint=1..}] run scoreboard players set @s paused 0
execute as @a[scores={paused=10..}] at @s run tp @e[tag=wallfloor,distance=5] 0.66 4.00 0.20

execute as @a[scores={paused=..9}] at @s anchored eyes unless entity @e[tag=wallfloor,distance=..2.5] if block ~1 ~ ~ polished_granite anchored feet run summon armor_stand ~ ~-2.5 ~ {NoGravity:1b,Passengers:[{id:"minecraft:shulker",Silent:1b,Invulnerable:1b,NoAI:1b,CanPickUpLoot:0b,Health:1f,AttachFace:0b,ActiveEffects:[{Id:14b,Amplifier:20b,Duration:99999,ShowParticles:0b}]}],Tags:["wallfloor"],DeathLootTable:"none",Invisible:1}
execute as @a[scores={paused=..9}] at @s anchored eyes unless entity @e[tag=wallfloor,distance=..2.5] if block ~-1 ~ ~ polished_granite anchored feet run summon armor_stand ~ ~-2.5 ~ {NoGravity:1b,Passengers:[{id:"minecraft:shulker",Silent:1b,Invulnerable:1b,NoAI:1b,CanPickUpLoot:0b,Health:1f,AttachFace:0b,ActiveEffects:[{Id:14b,Amplifier:20b,Duration:99999,ShowParticles:0b}]}],Tags:["wallfloor"],DeathLootTable:"none",Invisible:1}
execute as @a[scores={paused=..9}] at @s anchored eyes unless entity @e[tag=wallfloor,distance=..2.5] if block ~ ~ ~1 polished_granite anchored feet run summon armor_stand ~ ~-2.5 ~ {NoGravity:1b,Passengers:[{id:"minecraft:shulker",Silent:1b,Invulnerable:1b,NoAI:1b,CanPickUpLoot:0b,Health:1f,AttachFace:0b,ActiveEffects:[{Id:14b,Amplifier:20b,Duration:99999,ShowParticles:0b}]}],Tags:["wallfloor"],DeathLootTable:"none",Invisible:1}
execute as @a[scores={paused=..9}] at @s anchored eyes unless entity @e[tag=wallfloor,distance=..2.5] if block ~ ~ ~-1 polished_granite anchored feet run summon armor_stand ~ ~-2.5 ~ {NoGravity:1b,Passengers:[{id:"minecraft:shulker",Silent:1b,Invulnerable:1b,NoAI:1b,CanPickUpLoot:0b,Health:1f,AttachFace:0b,ActiveEffects:[{Id:14b,Amplifier:20b,Duration:99999,ShowParticles:0b}]}],Tags:["wallfloor"],DeathLootTable:"none",Invisible:1}

#Once the shulker is 1.5 blocks away from the players feet, it is teleport it to 0.66 4 0.2 where it will be killed. This prevents extra entities from existing in the world and also prevents death particles from appearing when the player jumps or moves on the wall.

execute as @e[tag=wallfloor] at @s unless entity @a[distance=..2.6] run tp @s 0.66 4.00 0.20

execute as @a at @s if block ~-1 ~ ~ minecraft:polished_granite run effect give @s speed 1 2 true
execute as @a at @s if block ~1 ~ ~ minecraft:polished_granite run effect give @s speed 1 2 true
execute as @a at @s if block ~ ~ ~-1 minecraft:polished_granite run effect give @s speed 1 2 true
execute as @a at @s if block ~ ~ ~1 minecraft:polished_granite run effect give @s speed 1 2 true